Package com.mckoi.database.sql

## Class SQL

- java.lang.Object
- - com.mckoi.database.sql.SQL

All Implemented Interfaces:
  `SQLConstants`

    public class SQL
    extends java.lang.Object
    implements SQLConstants

### Field Summary

Fields
`Token` `jj_nt`
`boolean` `lookingAhead`
`Token` `token`
`SQLTokenManager` `token_source`

### Fields inherited from interface com.mckoi.database.sql.SQLConstants

`ACCOUNT, ACTION, ADD, AFTER, ALL, ALTER, AND, ANY, AS, ASC, ASSIGNMENT, AUTOCOMMIT, BEFORE, BETWEEN, BIGINT, BINARY, BIT, BLOB, BOOLEAN, BOOLEAN_LITERAL, BOTH, CACHE, CALL, CALLBACK, CANONICAL_DECOMPOSITION, CASCADE, CAST, CHAR, CHARACTER, CHECK, CLOB, COLLATE, COMMIT, COMPACT, CONCAT, CONSTRAINT, COUNT, CREATE, CROSS, CTALIAS, CURRENT_DATE, CURRENT_TIME, CURRENT_TIMESTAMP, CYCLE, DATE, DECIMAL, DEFAULT, DEFERRABLE, DEFERRED, DELETE, DESC, DESCRIBE, DIGIT, DISTINCT, DIVIDE, DOT_DELIMINATED_REF, DOUBLE, DROP, EACH, EOF, EQUALS, EXCEPT, EXECUTE, EXISTS, EXPLAIN, FLOAT, FOR, FOREIGN, FROM, FULL_DECOMPOSITION, FUNCTION, GLOBVARIABLE, GR, GRANT, GREQ, GROUPBY, GROUPMAX, GROUPS, HAVING, IDENTICAL_STRENGTH, IDENTIFIER, IF, IGNORE, IMMEDIATE, IN, INCREMENT, INDEX, INDEX_BLIST, INDEX_NONE, INITIALLY, INNER, INSERT, INT, INTEGER, INTERSECT, INTO, IS, JAVA, JAVA_OBJECT, JAVA_OBJECT_ARRAY_REF, JOIN, KEY, LANGUAGE, LE, LEADING, LEEQ, LEFT, LETTER, LIKE, LIMIT, LOCK, LONG, LONGVARBINARY, LONGVARCHAR, MAXVALUE, MINVALUE, NAME, NATURAL, NEW, NO, NO_DECOMPOSITION, NOT, NOTEQ, NULL_LITERAL, NUMBER_LITERAL, NUMERIC, OLD, ON, OPTIMIZE, OPTION, OR, ORDERBY, OUTER, PARAMETER_REF, PASSWORD, PRIMARY, PRIMARY_STRENGTH, PRIVILEGES, PROCEDURE, PUBLIC, QUOTED_DELIMINATED_REF, QUOTED_VARIABLE, QUOTEDGLOBVARIABLE, READCOMMITTED, READUNCOMMITTED, REAL, REFERENCES, REGEX, REGEX_LITERAL, REPEATABLEREAD, RESTRICT, RETURNS, REVOKE, RIGHT, ROLLBACK, ROW, SCHEMA, SECONDARY_STRENGTH, SELECT, SEQUENCE, SERIALIZABLE, SET, SHOW, SHUTDOWN, SMALLINT, SOME, SQLADD, SQLCOLUMN, SQLDEFAULT, SQLRETURN, STAR, START, STRING, STRING_LITERAL, SUBTRACT, TABLE, TEMPORARY, TERTIARY_STRENGTH, TEXT, TIME, TIMESTAMP, TINYINT, TO, tokenImage, TRAILING, TRANSACTIONISOLATIONLEVEL, TRIGGER, TRIM, UNION, UNIQUE, UNLOCK, UPDATE, USAGE, USE, USER, USING, VALUES, VARBINARY, VARCHAR, VARYING, VIEW, WHERE, WITH`

### Constructor Summary

Constructors
`SQL​(SQLTokenManager tm)`
`SQL​(java.io.InputStream stream)`
`SQL​(java.io.Reader stream)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `addOperatorToExpression​(Expression exp, Operator op)` Helper for expression parsing.
`StatementTree` `Alter()`
`StatementTree` `AlterTable()`
`StatementTree` `AlterUser()`
`void` `AssignmentList​(java.util.ArrayList assignment_list)`
`java.util.ArrayList` `BasicColumnList​(java.util.ArrayList list)`
`java.lang.String` `BeforeOrAfter()`
`void` `BetweenPredicate​(Expression exp, java.util.Stack stack)`
`void` `BooleanOperator​(Expression exp, java.util.Stack stack)`
`StatementTree` `Call()`
`java.lang.String` `caseCheck​(java.lang.String identif)` If the parser has been defined as case insensitive then this returns the uppercase version of the given string.
`void` `ColumnConstraint​(ColumnDef column)`
`void` `ColumnDataType​(ColumnDef column)`
`void` `ColumnDeclarationList​(java.util.ArrayList column_list, java.util.ArrayList constraint_list)`
`ColumnDef` `ColumnDefinition()`
`java.lang.String` `ColumnName()`
`Variable` `ColumnNameVariable()`
`void` `ColumnOrConstraintDefinition​(java.util.ArrayList column_list, java.util.ArrayList constraint_list)`
`StatementTree` `Compact()`
`StatementTree` `CompleteTransaction()`
`void` `ConditionsExpression​(SearchExpression se)`
`void` `ConstraintAttributes​(ConstraintDef constraint)`
`java.lang.String` `ConstraintName()`
`StatementTree` `Create()`
`StatementTree` `CreateFunction()`
`StatementTree` `CreateIndex()`
`StatementTree` `CreateSchema()`
`StatementTree` `CreateSequence()`
`ParameterSubstitution` `createSubstitution​(java.lang.String image)` Creates and returns a parameter substitution.
`StatementTree` `CreateTable()`
`StatementTree` `CreateTrigger()`
`StatementTree` `CreateUser()`
`StatementTree` `CreateView()`
`StatementTree` `Delete()`
`StatementTree` `Describe()`
`void` `disable_tracing()`
`Expression` `DoExpression()`
`Expression` `DoNonBooleanExpression()`
`StatementTree` `Drop()`
`StatementTree` `DropFunction()`
`StatementTree` `DropIndex()`
`StatementTree` `DropSchema()`
`StatementTree` `DropSequence()`
`StatementTree` `DropTable()`
`StatementTree` `DropTrigger()`
`StatementTree` `DropUser()`
`StatementTree` `DropView()`
`void` `enable_tracing()`
`void` `expEnd​(Expression exp, java.util.Stack stack)` Helper for expression parsing.
`void` `expEndParen​(Expression exp, java.util.Stack stack)` Helper for expression parsing.
`void` `expOperator​(Expression exp, java.util.Stack stack, Operator op)` Helper for expression parsing.
`void` `expression​(Expression exp, java.util.Stack stack)` Parse an expression.
`Expression[]` `ExpressionList()`
`Expression` `ExpressionTest()`
`void` `flushOperatorStack​(Expression exp, java.util.Stack stack, int precedence)` Flush the operator stack until the stack is either empty or the top element is either a "(" or of a precedence lower than the given precedence.
`void` `FromClauseJoin​(FromClause from_clause)`
`FunctionDef` `Function()`
`Token` `FunctionIdentifier()`
`java.lang.String` `FunctionName()`
`Expression[]` `FunctionParams()`
`ParseException` `generateParseException()`
`AlterTableAction` `GetAlterTableAction()`
`int` `GetBinarySQLType()`
`java.lang.String` `GetBooleanOperator()`
`int` `GetBooleanSQLType()`
`int` `GetCollateDecomposition()`
`int` `GetCollateStrength()`
`java.lang.String` `GetComposite()`
`int` `GetDateSQLType()`
`Token` `getNextToken()`
`java.lang.String` `GetNumericOperator()`
`int` `GetNumericSQLType()`
`java.lang.String` `GetStringOperator()`
`int` `GetStringSQLType()`
`java.lang.String` `GetSubQueryBooleanOperator()`
`TableSelectExpression` `GetTableSelectExpression()`
`Token` `getToken​(int index)`
`TType` `GetTType()`
`StatementTree` `Grant()`
`Variable` `GroupMaxColumn()` NOTE: This is an extension, allows for us to specify a column to return the max value for each row representing a group.
`java.lang.String` `IndexName()`
`StatementTree` `Insert()`
`void` `InsertDataList​(java.util.ArrayList data_list)`
`java.lang.Object` `InsertElement()`
`java.util.ArrayList` `InsertExpressionList()`
`FunctionDef` `JavaInstantiation()`
`static void` `main​(java.lang.String[] args)`
`void` `nonBooleanExpression​(Expression exp, java.util.Stack stack)` Parses a non-boolean expression.
`void` `NumericOperator​(Expression exp, java.util.Stack stack)`
`void` `Operand​(Expression exp, java.util.Stack stack)`
`void` `OpPart​(Expression exp, java.util.Stack stack)`
`boolean` `OrderingSpec()`
`Expression` `parseExpression()`
`int` `PositiveIntegerConstant()`
`java.util.ArrayList` `PrivList​(java.util.ArrayList list)`
`void` `PrivListItem​(java.util.ArrayList list)`
`java.lang.String` `PrivObject()`
`java.lang.String` `ProcArgumentName()`
`java.lang.String` `ProcedureName()`
`void` `ProcParameterList​(java.util.ArrayList decl_names, java.util.ArrayList decl_types)`
`java.lang.String` `ReferentialTrigger()`
`void` `ReInit​(SQLTokenManager tm)`
`void` `ReInit​(java.io.InputStream stream)`
`void` `ReInit​(java.io.Reader stream)`
`void` `reset()` Resets the parameter id.
`StatementTree` `Revoke()`
`java.lang.String` `SchemaName()`
`StatementTree` `Select()`
`SelectColumn` `SelectColumn()`
`void` `SelectColumnList​(java.util.ArrayList list)`
`void` `SelectGroupByList​(java.util.ArrayList list)`
`void` `SelectOrderByList​(java.util.ArrayList list)`
`void` `SelectTableList​(FromClause from_clause)`
`java.lang.String` `SequenceName()`
`StatementTree` `Set()`
`boolean` `SetQuantifier()`
`StatementTree` `Show()`
`StatementTree` `ShutDown()`
`Token` `SQLIdentifier()`
`StatementTree` `Statement()`
`void` `StringOperator​(Expression exp, java.util.Stack stack)`
`void` `SubQueryExpression​(Expression exp, java.util.Stack stack)`
`void` `SubQueryOperator​(Expression exp, java.util.Stack stack)`
`java.lang.String` `TableAliasName()`
`ConstraintDef` `TableConstraintDefinition()`
`void` `TableDeclaration​(FromClause from_clause)`
`java.lang.String` `TableName()`
`void` `Test()`
`java.lang.String` `TriggerName()`
`java.lang.String` `TriggerType()`
`void` `TriggerTypes​(java.util.ArrayList list)`
`StatementTree` `Update()`
`void` `UserManagerCommand​(StatementTree cmd)`
`java.lang.String` `UserName()`
`java.util.ArrayList` `UserNameList​(java.util.ArrayList list)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### token_source

    public SQLTokenManager token_source

#### token

    public Token token

#### jj_nt

    public Token jj_nt

#### lookingAhead

    public boolean lookingAhead

### Constructor Detail

#### SQL

    public SQL​(java.io.InputStream stream)

#### SQL

    public SQL​(java.io.Reader stream)

#### SQL

    public SQL​(SQLTokenManager tm)

### Method Detail

#### reset

    public void reset()

Resets the parameter id. This MUST be called before a parser is used to parse a statement.

#### createSubstitution

    public ParameterSubstitution createSubstitution​(java.lang.String image)

Creates and returns a parameter substitution. This is called when the parser comes across a '?' style object. This object is used to mark an expression with a place mark that can be substituted for a value later.

#### caseCheck

    public java.lang.String caseCheck​(java.lang.String identif)

If the parser has been defined as case insensitive then this returns the uppercase version of the given string. NOTE: This actually doesn't do anything because the case is now resolved outside the parser.

#### expEndParen

    public void expEndParen​(Expression exp,
                            java.util.Stack stack)

Helper for expression parsing. Called when an end parenthese has been found.

#### expOperator

    public void expOperator​(Expression exp,
                            java.util.Stack stack,
                            Operator op)

Helper for expression parsing. Called when an operator has been read in. This needs to check precedence and add the operator to the expression as appropriate.

#### flushOperatorStack

    public void flushOperatorStack​(Expression exp,
                                   java.util.Stack stack,
                                   int precedence)

Flush the operator stack until the stack is either empty or the top element is either a "(" or of a precedence lower than the given precedence.

#### expEnd

    public void expEnd​(Expression exp,
                       java.util.Stack stack)

Helper for expression parsing. Called when an entire expression has been read in. We need to empty the stack.

#### addOperatorToExpression

    public void addOperatorToExpression​(Expression exp,
                                        Operator op)

Helper for expression parsing. Adds an operator to the given expression.

#### main

    public static void main​(java.lang.String[] args)
                     throws ParseException

Throws:
  `ParseException`

#### Test

    public final void Test()
                    throws ParseException

Throws:
  `ParseException`

#### parseExpression

    public final Expression parseExpression()
                                     throws ParseException

Throws:
  `ParseException`

#### Statement

    public final StatementTree Statement()
                                  throws ParseException

Throws:
  `ParseException`

#### Create

    public final StatementTree Create()
                               throws ParseException

Throws:
  `ParseException`

#### Drop

    public final StatementTree Drop()
                             throws ParseException

Throws:
  `ParseException`

#### Select

    public final StatementTree Select()
                               throws ParseException

Throws:
  `ParseException`

#### Update

    public final StatementTree Update()
                               throws ParseException

Throws:
  `ParseException`

#### Alter

    public final StatementTree Alter()
                              throws ParseException

Throws:
  `ParseException`

#### AlterTable

    public final StatementTree AlterTable()
                                   throws ParseException

Throws:
  `ParseException`

#### Compact

    public final StatementTree Compact()
                                throws ParseException

Throws:
  `ParseException`

#### CreateTable

    public final StatementTree CreateTable()
                                    throws ParseException

Throws:
  `ParseException`

#### CreateTrigger

    public final StatementTree CreateTrigger()
                                      throws ParseException

Throws:
  `ParseException`

#### DropTrigger

    public final StatementTree DropTrigger()
                                    throws ParseException

Throws:
  `ParseException`

#### CreateFunction

    public final StatementTree CreateFunction()
                                       throws ParseException

Throws:
  `ParseException`

#### DropFunction

    public final StatementTree DropFunction()
                                     throws ParseException

Throws:
  `ParseException`

#### CreateSchema

    public final StatementTree CreateSchema()
                                     throws ParseException

Throws:
  `ParseException`

#### DropSchema

    public final StatementTree DropSchema()
                                   throws ParseException

Throws:
  `ParseException`

#### CreateView

    public final StatementTree CreateView()
                                   throws ParseException

Throws:
  `ParseException`

#### DropView

    public final StatementTree DropView()
                                 throws ParseException

Throws:
  `ParseException`

#### CreateIndex

    public final StatementTree CreateIndex()
                                    throws ParseException

Throws:
  `ParseException`

#### DropTable

    public final StatementTree DropTable()
                                  throws ParseException

Throws:
  `ParseException`

#### DropIndex

    public final StatementTree DropIndex()
                                  throws ParseException

Throws:
  `ParseException`

#### Call

    public final StatementTree Call()
                             throws ParseException

Throws:
  `ParseException`

#### CreateSequence

    public final StatementTree CreateSequence()
                                       throws ParseException

Throws:
  `ParseException`

#### DropSequence

    public final StatementTree DropSequence()
                                     throws ParseException

Throws:
  `ParseException`

#### CreateUser

    public final StatementTree CreateUser()
                                   throws ParseException

Throws:
  `ParseException`

#### AlterUser

    public final StatementTree AlterUser()
                                  throws ParseException

Throws:
  `ParseException`

#### DropUser

    public final StatementTree DropUser()
                                 throws ParseException

Throws:
  `ParseException`

#### UserManagerCommand

    public final void UserManagerCommand​(StatementTree cmd)
                                  throws ParseException

Throws:
  `ParseException`

#### Delete

    public final StatementTree Delete()
                               throws ParseException

Throws:
  `ParseException`

#### Insert

    public final StatementTree Insert()
                               throws ParseException

Throws:
  `ParseException`

#### Describe

    public final StatementTree Describe()
                                 throws ParseException

Throws:
  `ParseException`

#### Show

    public final StatementTree Show()
                             throws ParseException

Throws:
  `ParseException`

#### Grant

    public final StatementTree Grant()
                              throws ParseException

Throws:
  `ParseException`

#### Revoke

    public final StatementTree Revoke()
                               throws ParseException

Throws:
  `ParseException`

#### CompleteTransaction

    public final StatementTree CompleteTransaction()
                                            throws ParseException

Throws:
  `ParseException`

#### Set

    public final StatementTree Set()
                            throws ParseException

Throws:
  `ParseException`

#### ShutDown

    public final StatementTree ShutDown()
                                 throws ParseException

Throws:
  `ParseException`

#### TriggerType

    public final java.lang.String TriggerType()
                                       throws ParseException

Throws:
  `ParseException`

#### BeforeOrAfter

    public final java.lang.String BeforeOrAfter()
                                         throws ParseException

Throws:
  `ParseException`

#### TriggerTypes

    public final void TriggerTypes​(java.util.ArrayList list)
                            throws ParseException

Throws:
  `ParseException`

#### PrivObject

    public final java.lang.String PrivObject()
                                      throws ParseException

Throws:
  `ParseException`

#### PrivList

    public final java.util.ArrayList PrivList​(java.util.ArrayList list)
                                       throws ParseException

Throws:
  `ParseException`

#### PrivListItem

    public final void PrivListItem​(java.util.ArrayList list)
                            throws ParseException

Throws:
  `ParseException`

#### GetTableSelectExpression

    public final TableSelectExpression GetTableSelectExpression()
                                                         throws ParseException

Throws:
  `ParseException`

#### GetAlterTableAction

    public final AlterTableAction GetAlterTableAction()
                                               throws ParseException

Throws:
  `ParseException`

#### InsertElement

    public final java.lang.Object InsertElement()
                                         throws ParseException

Throws:
  `ParseException`

#### InsertExpressionList

    public final java.util.ArrayList InsertExpressionList()
                                                   throws ParseException

Throws:
  `ParseException`

#### InsertDataList

    public final void InsertDataList​(java.util.ArrayList data_list)
                              throws ParseException

Throws:
  `ParseException`

#### SetQuantifier

    public final boolean SetQuantifier()
                                throws ParseException

Throws:
  `ParseException`

#### SelectColumnList

    public final void SelectColumnList​(java.util.ArrayList list)
                                throws ParseException

Throws:
  `ParseException`

#### SelectColumn

    public final SelectColumn SelectColumn()
                                    throws ParseException

Throws:
  `ParseException`

#### SelectGroupByList

    public final void SelectGroupByList​(java.util.ArrayList list)
                                 throws ParseException

Throws:
  `ParseException`

#### GroupMaxColumn

    public final Variable GroupMaxColumn()
                                  throws ParseException

NOTE: This is an extension, allows for us to specify a column to return the max value for each row representing a group.

Throws:
  `ParseException`

#### SelectOrderByList

    public final void SelectOrderByList​(java.util.ArrayList list)
                                 throws ParseException

Throws:
  `ParseException`

#### OrderingSpec

    public final boolean OrderingSpec()
                               throws ParseException

Throws:
  `ParseException`

#### TableDeclaration

    public final void TableDeclaration​(FromClause from_clause)
                                throws ParseException

Throws:
  `ParseException`

#### SelectTableList

    public final void SelectTableList​(FromClause from_clause)
                               throws ParseException

Throws:
  `ParseException`

#### FromClauseJoin

    public final void FromClauseJoin​(FromClause from_clause)
                              throws ParseException

Throws:
  `ParseException`

#### ProcParameterList

    public final void ProcParameterList​(java.util.ArrayList decl_names,
                                        java.util.ArrayList decl_types)
                                 throws ParseException

Throws:
  `ParseException`

#### AssignmentList

    public final void AssignmentList​(java.util.ArrayList assignment_list)
                              throws ParseException

Throws:
  `ParseException`

#### ColumnDeclarationList

    public final void ColumnDeclarationList​(java.util.ArrayList column_list,
                                            java.util.ArrayList constraint_list)
                                     throws ParseException

Throws:
  `ParseException`

#### ColumnOrConstraintDefinition

    public final void ColumnOrConstraintDefinition​(java.util.ArrayList column_list,
                                                   java.util.ArrayList constraint_list)
                                            throws ParseException

Throws:
  `ParseException`

#### ColumnDefinition

    public final ColumnDef ColumnDefinition()
                                     throws ParseException

Throws:
  `ParseException`

#### ColumnConstraint

    public final void ColumnConstraint​(ColumnDef column)
                                throws ParseException

Throws:
  `ParseException`

#### GetCollateStrength

    public final int GetCollateStrength()
                                 throws ParseException

Throws:
  `ParseException`

#### GetCollateDecomposition

    public final int GetCollateDecomposition()
                                      throws ParseException

Throws:
  `ParseException`

#### GetStringSQLType

    public final int GetStringSQLType()
                               throws ParseException

Throws:
  `ParseException`

#### GetNumericSQLType

    public final int GetNumericSQLType()
                                throws ParseException

Throws:
  `ParseException`

#### GetBooleanSQLType

    public final int GetBooleanSQLType()
                                throws ParseException

Throws:
  `ParseException`

#### GetDateSQLType

    public final int GetDateSQLType()
                             throws ParseException

Throws:
  `ParseException`

#### GetBinarySQLType

    public final int GetBinarySQLType()
                               throws ParseException

Throws:
  `ParseException`

#### GetTType

    public final TType GetTType()
                         throws ParseException

Throws:
  `ParseException`

#### ColumnDataType

    public final void ColumnDataType​(ColumnDef column)
                              throws ParseException

Throws:
  `ParseException`

#### TableConstraintDefinition

    public final ConstraintDef TableConstraintDefinition()
                                                  throws ParseException

Throws:
  `ParseException`

#### ReferentialTrigger

    public final java.lang.String ReferentialTrigger()
                                              throws ParseException

Throws:
  `ParseException`

#### ConstraintAttributes

    public final void ConstraintAttributes​(ConstraintDef constraint)
                                    throws ParseException

Throws:
  `ParseException`

#### BasicColumnList

    public final java.util.ArrayList BasicColumnList​(java.util.ArrayList list)
                                              throws ParseException

Throws:
  `ParseException`

#### UserNameList

    public final java.util.ArrayList UserNameList​(java.util.ArrayList list)
                                           throws ParseException

Throws:
  `ParseException`

#### ConditionsExpression

    public final void ConditionsExpression​(SearchExpression se)
                                    throws ParseException

Throws:
  `ParseException`

#### ExpressionTest

    public final Expression ExpressionTest()
                                    throws ParseException

Throws:
  `ParseException`

#### DoExpression

    public final Expression DoExpression()
                                  throws ParseException

Throws:
  `ParseException`

#### DoNonBooleanExpression

    public final Expression DoNonBooleanExpression()
                                            throws ParseException

Throws:
  `ParseException`

#### expression

    public final void expression​(Expression exp,
                                 java.util.Stack stack)
                          throws ParseException

Parse an expression.

Throws:
  `ParseException`

#### nonBooleanExpression

    public final void nonBooleanExpression​(Expression exp,
                                           java.util.Stack stack)
                                    throws ParseException

Parses a non-boolean expression.

Throws:
  `ParseException`

#### OpPart

    public final void OpPart​(Expression exp,
                             java.util.Stack stack)
                      throws ParseException

Throws:
  `ParseException`

#### Operand

    public final void Operand​(Expression exp,
                              java.util.Stack stack)
                       throws ParseException

Throws:
  `ParseException`

#### SubQueryExpression

    public final void SubQueryExpression​(Expression exp,
                                         java.util.Stack stack)
                                  throws ParseException

Throws:
  `ParseException`

#### PositiveIntegerConstant

    public final int PositiveIntegerConstant()
                                      throws ParseException

Throws:
  `ParseException`

#### SubQueryOperator

    public final void SubQueryOperator​(Expression exp,
                                       java.util.Stack stack)
                                throws ParseException

Throws:
  `ParseException`

#### BetweenPredicate

    public final void BetweenPredicate​(Expression exp,
                                       java.util.Stack stack)
                                throws ParseException

Throws:
  `ParseException`

#### BooleanOperator

    public final void BooleanOperator​(Expression exp,
                                      java.util.Stack stack)
                               throws ParseException

Throws:
  `ParseException`

#### NumericOperator

    public final void NumericOperator​(Expression exp,
                                      java.util.Stack stack)
                               throws ParseException

Throws:
  `ParseException`

#### StringOperator

    public final void StringOperator​(Expression exp,
                                     java.util.Stack stack)
                              throws ParseException

Throws:
  `ParseException`

#### GetBooleanOperator

    public final java.lang.String GetBooleanOperator()
                                              throws ParseException

Throws:
  `ParseException`

#### GetSubQueryBooleanOperator

    public final java.lang.String GetSubQueryBooleanOperator()
                                                      throws ParseException

Throws:
  `ParseException`

#### GetNumericOperator

    public final java.lang.String GetNumericOperator()
                                              throws ParseException

Throws:
  `ParseException`

#### GetStringOperator

    public final java.lang.String GetStringOperator()
                                             throws ParseException

Throws:
  `ParseException`

#### FunctionIdentifier

    public final Token FunctionIdentifier()
                                   throws ParseException

Throws:
  `ParseException`

#### Function

    public final FunctionDef Function()
                               throws ParseException

Throws:
  `ParseException`

#### JavaInstantiation

    public final FunctionDef JavaInstantiation()
                                        throws ParseException

Throws:
  `ParseException`

#### FunctionParams

    public final Expression[] FunctionParams()
                                      throws ParseException

Throws:
  `ParseException`

#### ExpressionList

    public final Expression[] ExpressionList()
                                      throws ParseException

Throws:
  `ParseException`

#### GetComposite

    public final java.lang.String GetComposite()
                                        throws ParseException

Throws:
  `ParseException`

#### TableName

    public final java.lang.String TableName()
                                     throws ParseException

Throws:
  `ParseException`

#### SequenceName

    public final java.lang.String SequenceName()
                                        throws ParseException

Throws:
  `ParseException`

#### TriggerName

    public final java.lang.String TriggerName()
                                       throws ParseException

Throws:
  `ParseException`

#### IndexName

    public final java.lang.String IndexName()
                                     throws ParseException

Throws:
  `ParseException`

#### UserName

    public final java.lang.String UserName()
                                    throws ParseException

Throws:
  `ParseException`

#### SchemaName

    public final java.lang.String SchemaName()
                                      throws ParseException

Throws:
  `ParseException`

#### ConstraintName

    public final java.lang.String ConstraintName()
                                          throws ParseException

Throws:
  `ParseException`

#### ColumnName

    public final java.lang.String ColumnName()
                                      throws ParseException

Throws:
  `ParseException`

#### ColumnNameVariable

    public final Variable ColumnNameVariable()
                                      throws ParseException

Throws:
  `ParseException`

#### TableAliasName

    public final java.lang.String TableAliasName()
                                          throws ParseException

Throws:
  `ParseException`

#### ProcedureName

    public final java.lang.String ProcedureName()
                                         throws ParseException

Throws:
  `ParseException`

#### FunctionName

    public final java.lang.String FunctionName()
                                        throws ParseException

Throws:
  `ParseException`

#### ProcArgumentName

    public final java.lang.String ProcArgumentName()
                                            throws ParseException

Throws:
  `ParseException`

#### SQLIdentifier

    public final Token SQLIdentifier()
                              throws ParseException

Throws:
  `ParseException`

#### ReInit

    public void ReInit​(java.io.InputStream stream)

#### ReInit

    public void ReInit​(java.io.Reader stream)

#### ReInit

    public void ReInit​(SQLTokenManager tm)

#### getNextToken

    public final Token getNextToken()

#### getToken

    public final Token getToken​(int index)

#### generateParseException

    public final ParseException generateParseException()

#### enable_tracing

    public final void enable_tracing()

#### disable_tracing

    public final void disable_tracing()